#ifndef mySemaphore_H
#define mySemaphore_H



//#define _CRTDBG_MAP_ALLOC			   //detect memory leaks
#include <stdlib.h>
#include <crtdbg.h>




#define OPEN 0
#define CREATE 1

#define _WIN32_WINNT 0x0400

#include <winsock2.h>			///must be included before windows.h
#include <windows.h>
#include <winuser.h>
#include <winbase.h>

#pragma warning (push)
#pragma warning (disable : 6011)		///warning C6011: Dereferencing NULL pointer '_Myptr': Lines: 108, 111, 112, 122
#include <string>
#pragma warning (pop)




#ifndef MYASSERT
	#ifdef _DEBUG
		#define MYASSERT(x)																    { /*DISABLE_WARNING(4127)*/ if (!(x)) __debugbreak(); /*END_DISABLE_WARNING*/ };
	#else
		#define MYASSERT(x)																	{};
	#endif
#endif		





class mySemaphore
{
///using namespace std;

public:

    mySemaphore(std::string &sName/* = std::string("")*/, long initialCount = 0, long maxCount = 1, int accessMode = CREATE, BOOL canInherit = TRUE);
    mySemaphore(char *cName, long initialCount = 0, long maxCount = 1, int accessMode = CREATE, BOOL canInherit = TRUE);

    virtual ~mySemaphore();



public:

    void closeSemaphore();
    
#if (1 || !defined(_DEBUG))
	BOOL lock
	(
		BOOL wait = TRUE, 
		DWORD milliseconds = 0
	);
#else
	BOOL lock
	(
		BOOL wait = FALSE, 
		DWORD milliseconds = 30000
	);
#endif	
	
    void unlock();



public:

	std::string getSemaphoreName()	{ return semaphoreName; }
	long    getInitialCount()		{ return initCount; }
    long    getMaxCount()			{ return maxCount; }
	BOOL    getInherit()			{ return inherit; }
	
	
	
private:

    void init_inner(std::string &sName, long initialCount, long maximumCount, int accessMode, BOOL canInherit);

	void getErrorDetail(int&, std::string&);



private:

	long initCount;   /// initialCount 
	long maxCount;    /// max count
    BOOL inherit;     /// can be inherited by child process

    std::string semaphoreName;
    HANDLE semaphore;
    LPSECURITY_ATTRIBUTES sa;
};




#include <list>

class myFlexiSemaphore : protected mySemaphore 
{

public:
	myFlexiSemaphore();
	~myFlexiSemaphore();

	void lock();
	void unlock();


protected:

	///int get_semaphores_taken_for_this_thread() C;

	///__declspec(thread) static int semaphores_taken_for_this_thread_a[256];		///declspec(thread) can be used only with static data
	int myindex;
	//mySemaphore *inner_lock; ///("myFlexiSemaphore_inner_lock", 1, 1, CREATE, TRUE);
	///static std::map<int, bool> free_indexes_map;
	///static std::list<int> free_indexes_list;

	///static mySemaphore inner_lock("myFlexiSemaphore_inner_lock");
	///static bool free_indexes_list_inited = false;

};



#endif
